#include "global.h"
#include "../ipc_module/ipc_shm.h"
void InvalidArgument();

void ProcessRunner(char* process_name, char *args[]);

int main(int argc, char *argv[]){

    if((argc==2)&&!strcmp(argv[1], "status")) {
        //status
        PrintProcessStatus();
    } else if((argc==3)&&(!strcmp(argv[1], "start")&&!strcmp(argv[2], "server"))){
        //start server
        char *argument[] = {"start",NULL};
        ProcessRunner("./server", argument);
    } else if((argc==3)&&(!strcmp(argv[1], "stop")&&!strcmp(argv[2], "server"))) {
        //stop server
        int pid = SelectProcessPID("server");
        if (pid !=-1){
            printf("server process has been stopped.\n");
            kill(pid,2);
        } else {
            printf("server process is not running.\n");
        }
    } else if((argc==4)&&(!strcmp(argv[1], "stop")&&!strcmp(argv[2], "client"))) {
        //stop client user
        int pid = SelectProcessPID(argv[3]);
        if (pid !=-1){
            printf("client process has been stopped.\n");
            kill(pid,2);
        } else {
            printf("client process is not running.\n");
        }
    } else {
        InvalidArgument();
    }

    return 0;
}

void ProcessRunner(char* process_name, char *args[]){
    pid_t pid=0;
    if((pid==fork())==0){
        if(execv(process_name,args)<0) {
            return;
        }
    }

}

void InvalidArgument(){
    char output[200]="Error: invalid argument!\n"
                     "status             Show process status\n"
                     "start server       Start server process\n"
                     "stop  server       Stop server process\n"
                     "stop  client <user> Stop client process by user arg";
    printf("%s\n",output);
    exit(0);
}