#include "global.h"
#include "../ipc_module/ipc_msq.h"
#include "../ipc_module/ipc_shm.h"
void StartupServer();
void ShutdownServer();
int main() {
    signal(2,ShutdownServer);
    StartupServer();
    //wait and enter, out log
    int enter_conter=0;
    char user[4][20];
    while(1){
        MsgContent recv_msg={};
        if(msgrcv(SelectMsqId(),&recv_msg,sizeof(MsgContent),0,1)==-1) {
            //error
            break;
        }
        if(recv_msg.status==STATUS_ENTER) {
            ++enter_conter;
            strcpy(user[enter_conter],recv_msg.sender);
            printf("# [%s] has entered. #\n",user[enter_conter]);
//            printf("counter %d\n",enter_conter);
            if(enter_conter==2){
                printf("# [%s] & [%s] enjoy chatting\n",user[1],user[2]);
            }
        }
        else if(recv_msg.status==STATUS_EXIT){
            printf("# [%s] Disconnect... #\n",recv_msg.sender);
            memset(user[enter_conter],0,20);
            enter_conter--;
//            printf("counter %d\n",enter_conter);
        }
    }
}

void StartupServer(){
    // check > shared mem checkin > make pipe line

    if(ShmIsExist()){
        printf("Info: already server or shared memory exist\n");
        return;
    }
    if(ShmInit(getpid())==-1){
        //error
        printf("Error: failed to create shared memory\n");
        return;
    }
    if(SelectMsqId()==-1){
        //error
        printf("Error: failed to create message queue\n");
        return;
    }
    printf("! Chatting server started !\n");
}

void ShutdownServer(){
    // check > remove messagequeue > shared mem checkout
    if(MsqDrop()==-1){
        printf("Error: failed drop message queue\n");
    }
    if(ShmDrop()==0){
        printf("Error: failed drop shared memory\n");
    }
    printf("! Chatting server shutdown !\n");
}